// ----- jjoo


#include <TimeLib.h>
#include <DS1307RTC.h>        //include RTC

#include <Wire.h>             //Include the Wire library
#include <MMA_7455.h>         //Include the MMA_7455 library          // Put sensor near the rotaional axis! ... or bad/unusable values!
#include <movingAvg.h>    

unsigned long time, periode;  // Timer for Period detection

int A = 6,        // Binary Output 2^0 for 74141 input A
    B = 8,        // Binary Output 2^1 for 74141 input B
    C = 9,        // Binary Output 2^2 for 74141 input C
    D = 7,        // Binary Output 2^3 for 74141 input D
    
    m=0,
    k=11,
    n,
    r=0,
    
    GradAbweichungvrnl,     // Difference in degree from right to left
    GradAbweichungvlnr,     // Difference in degree from left to right
    steps,                  // Number of Degree between displayd numbers
    hz,                     // hours tens
    he,                     // hours ones
    mz,                     // minutes tens
    me,                     // minutes ones
    avgx,                   // avg angle
    xold,                   // last meassured angle 
    richtung,               // direction 1 for left to right and -1 from right to left (maybe the other way ardound)
    richtung2,              // direction2
    avgy,                   // not needet but still there (it dosent move along this axis)
    
    avg=8,                  // average of 8 last values
    Loopcount;   

movingAvg yValM(avg),xValM(avg);      // taking average values from angle made the programm smoother - but delays the angle input and shrinks the amplitude of pendulum deviation a bit.


/*
      digitalWrite(A, DeziBin[m][0]);
      digitalWrite(B, DeziBin[m][1]);
      digitalWrite(C, DeziBin[m][2]);
      digitalWrite(D, DeziBin[m][3]);

*/

// mapping decimal from software for binary hardware output from arduino / input for 74141 driver. 
// NOTICE: If you mess up any order from the In- or/and Outputs from 74141 you can correct them here - IF you exacly find out what you messed up.

bool DeziBin [10][4] =                      
{            //DeziBin[ZahlDezi][zahlBin]
   //D,C,B,A   
    {LOW,LOW,LOW,LOW},      //0    
    {LOW,LOW,LOW,HIGH},     //1            
    {LOW,LOW,HIGH,LOW},     //2
    {LOW,LOW,HIGH,HIGH},    //3
    {LOW,HIGH,LOW,LOW},     //4
    {LOW,HIGH,LOW,HIGH},    //5
    {LOW,HIGH,HIGH,LOW},    //6
    {LOW,HIGH,HIGH,HIGH},   //7
    {HIGH,LOW,LOW,LOW},     //8
    {HIGH,LOW,LOW,HIGH},    //9
    
};






MMA_7455 mySensor = MMA_7455();               //Make an instance of MMA_7455

char xVal, yVal, zVal;                   //Variables for the values from the sensor


void setup()
{
  Serial.begin(250000);             // for debugging serial output you need fast seialspeed for higher performance
  
  xValM.begin();
  yValM.begin();
  
  Wire.setClock(100000);            // old wireing and defective MMA_7455 Accelerometer made me slow i²c down. Might work with 400k now
  
pinMode(13, OUTPUT);                // Signal for MOSFETT-air coil driver, when pendulum perpendicular to ground

pinMode(A, OUTPUT);
pinMode(B, OUTPUT);
pinMode(C, OUTPUT);
pinMode(D, OUTPUT);

                        // Set the sensitivity you want to use
                        // 2 = 2g, 4 = 4g, 8 = 8g
  mySensor.initSensitivity(2);
                        // Calibrate the Offset, that values corespond in 
                        // flat position to: xVal = -30, yVal = -20, zVal = +20
                        // !!!Activate this after having the first values read out!!!
  mySensor.calibrateOffset(-5, -43.2, 12.43);
  
  readtime();
}



void loop()
{
  xVal = mySensor.readAxis('x');        //Read out the 'x' Axis        
  yVal = mySensor.readAxis('y');        //Read out the 'y' Axis
 // zVal = mySensor.readAxis('z'); //Read out the 'x' Axis

xold  = avgx;

avgx = xValM.reading(xVal);               // build up average x
avgy = yValM.reading(yVal);               // build up average y .. yeah, yaeh. we dont need you - but you can stay.

  
//  periode = time - micros();                 // This system is not time sensitive, but i still wished the uC would be a lot faster. With the exact period one could the same output-timing for the nixie-tube.
//  time = micros();
//  Serial.println(periode); //prints time since program started
//intervall= micros()- timerclock2;                                     // Intervall zwischen den Messungen
//samplerate=1/(intervall*0.001);                                      // SPS - Samples pro Sekunde
//timerclock2 = (micros());



if(avgx == 0) {digitalWrite(13, HIGH);}         // If the slightly timedelayd angle (avgx) of Accelerometer looks sraight to the ground, then fire up the air coil to push the magnet away
else digitalWrite(13, LOW);                     // otherwise it dont

delay(4);                                       // ... for atleast 4 ms.


richtung = xold - avgx ;      // figure out the swing direction

if(richtung > 0) richtung2 = 1;     // set direction as var.  1 = from left to right
if(richtung < 0) richtung2 = -1;    // set direction as var. -1 = from right to left

/*        // wrong method
if (avgx>0)richtung  = 1;
if (avgx==0)richtung = 0;     // i dont need that zero
if (avgx<0)richtung  =-1;
*/

//  Serial.print(xVal,DEC);Serial.print(",");      --- Debug outputs
//  Serial.print(avgx,DEC);Serial.print(",");
//  Serial.print(richtung2);Serial.print(",");
//  Serial.print(yVal,DEC);Serial.print(",");
// Serial.print(avgy,DEC);Serial.print(","); 
//  Serial.print(zVal,DEC);//Serial.print(",");
//  Serial.println();


  if(m!=k)                      // display/show already choosen numbers for 2ms once
  {
      digitalWrite(D, DeziBin[m][0]);
      digitalWrite(C, DeziBin[m][1]);
      digitalWrite(B, DeziBin[m][2]);
      digitalWrite(A, DeziBin[m][3]);
      delay(2);
      k=m;                      // lock display for last number, for the possibility that next loopcycle is stil in same meassured degree - no float.
  }   
  
  Loopcount++;
  
  if(Loopcount<=500)        // If 500th cycle readout time again
  {
  readtime();
    Loopcount=0;
  }  
  
  steps=4;                     //4                  // Triky PART !!    .--- 4 Degree distance between numbers
  GradAbweichungvrnl= -7;     //-8;                 // if you go from right to left tune degrees for display
  GradAbweichungvlnr= 4;      //3;                  // if you go from left to right tune degrees for display
  
  
                              // If you go from left to right display numbers with and on tuned degrees - set position of array
  if(richtung2==1)            // Alle Zahlen / Positionen ... von links nach rechts !
  {
  if(avgx==2*steps+GradAbweichungvlnr){m=hz;}
  if(avgx==1*steps+GradAbweichungvlnr){m=he;}
  //if(avgx==0*steps){}
  if(avgx==-1*steps+GradAbweichungvlnr){m=mz;}
  if(avgx==-2*steps+GradAbweichungvlnr){m=me;}
  }
  
                              // If you go from right to left display numbers with and on tuned degrees - set position of array
  if(richtung2==-1)           // Alle Zahlen / Positionen ... von rechts nach links !
  {
  if(avgx==2*steps+GradAbweichungvrnl){m=hz;}
  if(avgx==1*steps+GradAbweichungvrnl){m=he;}
  //if(avgx==0*steps-GradAbweichungvrnl){}
  if(avgx==-1*steps+GradAbweichungvrnl){m=mz;}
  if(avgx==-2*steps+GradAbweichungvrnl){m=me;}
  }

  digitalWrite(D, HIGH);            // all off !
  digitalWrite(C, HIGH);
  digitalWrite(B, HIGH);
  digitalWrite(A, HIGH);








      
                            // Test all numbers - both directions
/*
if(richtung2==1)            // Test alle Zahlen / Positionen
{
if(avgx==5*steps){m=0;}
if(avgx==4*steps){m=1;}
if(avgx==3*steps){m=2;}
if(avgx==2*steps){m=3;}
if(avgx==1*steps){m=4;}
if(avgx==0*steps){m=5;}
if(avgx==-1*steps){m=6;}
if(avgx==-2*steps){m=7;}
if(avgx==-3*steps){m=8;}
if(avgx==-4*steps){m=9;}
}
if(richtung2==-1)           // Test alle Zahlen / Positionen
{
if(avgx==5*steps-GradAbweichung){m=0;}
if(avgx==4*steps-GradAbweichung){m=1;}
if(avgx==3*steps-GradAbweichung){m=2;}
if(avgx==2*steps-GradAbweichung){m=3;}
if(avgx==1*steps-GradAbweichung){m=4;}
if(avgx==0*steps-GradAbweichung){m=5;}
if(avgx==-1*steps-GradAbweichung){m=6;}
if(avgx==-2*steps-GradAbweichung){m=7;}
if(avgx==-3*steps-GradAbweichung){m=8;}
if(avgx==-4*steps-GradAbweichung){m=9;}
}
*/

    //delay(1);

      
/*            ----TEST All numbers
  if (m<10)
    {
      digitalWrite(D, DeziBin[m][0]);
      digitalWrite(C, DeziBin[m][1]);
      digitalWrite(B, DeziBin[m][2]);
      digitalWrite(A, DeziBin[m][3]);
    }
    m++;
    if(m==10) m=0;
  
  delay(500);
*/

}


                                // did i even unse this ?

void print2digits(int number) {
  if (number >= 0 && number < 10) {
    Serial.write('0');
  }
  Serial.print(number);
}





void readtime()                             //   my aproach to get single variables out of the time from RTC
{
    tmElements_t tm;
if (RTC.read(tm)) 
  {
    if (tm.Hour<10)               hz=0;             // Stunde Zehner
    if (tm.Hour>=10&&tm.Hour<20)  hz=1;
    if (tm.Hour>=20)              hz=2;

    if (tm.Hour<10)               he = tm.Hour;     // Stunde Einser
    if (tm.Hour>=10&&tm.Hour<20)  he=tm.Hour-10;
    if (tm.Hour>=20)              he=tm.Hour-20;
    
 //   hz,he,mz,me
 //   tm.Hour;
 //   tm.Minute;
 
    if (tm.Minute<10)                mz = 0;        // Minute Zehner
    if (tm.Minute>=10&&tm.Minute<20) mz = 1;
    if (tm.Minute>=20&&tm.Minute<30) mz = 2;
    if (tm.Minute>=30&&tm.Minute<40) mz = 3;
    if (tm.Minute>=40&&tm.Minute<50) mz = 4;
    if (tm.Minute>=50)               mz = 5;

    if (tm.Minute<10)                me = tm.Minute;        // Stunde Einser
    if (tm.Minute>=10&&tm.Minute<20) me = tm.Minute-10;
    if (tm.Minute>=20&&tm.Minute<30) me = tm.Minute-20;
    if (tm.Minute>=30&&tm.Minute<40) me = tm.Minute-30;
    if (tm.Minute>=40&&tm.Minute<50) me = tm.Minute-40;
    if (tm.Minute>=50)               me = tm.Minute-50;
    
  }
}